<?php
/* ---------- REQUIREMENTS MATCH CHECKING SCRIPT --------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- Use this script to enable your customers to easily find out whether your PHP scripts will run ---------------- */
/* ---------- on their servers. Just set a few basic settings and include this script with your own distribution. ---------- */
/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- (C) mo666, 2003. This script is available to the public under the terms of the General Public License. ------- */
/* ---------- In case you did not receive a copy of the license with this script, please get it at ------------------------- */
/* ---------- http://www.fsf.org/licenses/gpl.txt now. --------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */


/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- define your scripts' requirements here ----------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */

/***** Type the name of your application                             *****/
$application_name       = "TorrentTrader v1.0";

/***** Type the email address of tech support for your application   *****/
$support_url            = "http://bittorrentportal.com/forums/forumdisplay.php?forumid=73";

/***** Is a minimum PHP version is required?                         *****/
/***** If so, set "true" (w/o quotation marks), otherwise "false"    *****/
$check_version_php      = true;

/***** Which is the minimum PHP version that will work?              *****/
$required_version_php   = "4.3.0";

/***** Is a minimum Zend Accelerator version required?               *****/
/***** If so, set "true" (w/o quotation marks), otherwise "false"    *****/
$check_version_zend     = true;

/***** Which is the minimum Zend Accelerator version that will work? *****/
$required_version_zend  = "0.0";

/***** Is a minimum MySQL version required?                          *****/
/***** If so, set "true" (w/o quotation marks), otherwise "false"    *****/
$check_version_mysql    = true;

/***** Which is the minimum MySQL version that will work?            *****/
$required_version_mysql = "3.0";

/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- do not edit anything below ----------------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */


/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- header ------------------------------------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */

function htmlheader() {
echo ('
<style type="text/css"><!--
body {background-color: #ffffff; color: #000000;}
body, td, th, h1, h2 {font-family: sans-serif;}
pre {margin: 0px; font-family: monospace;}
a:link {color: #000099; text-decoration: none;}
a:hover {text-decoration: underline;}
table {border-collapse: collapse;}
td, th {border: 1px solid #000000; font-size: 75%; vertical-align: baseline;}
h1 {font-size: 150%;}
h2 {font-size: 125%;}
.p {text-align: left;}
.e {background-color: #ccccff; font-weight: bold;}
.h {background-color: #9999cc; font-weight: bold;}
.v {background-color: #cccccc;}
i {color: #666666;}
img {float: right; border: 0px;}
hr {width: 600px; align: center; background-color: #cccccc; border: 0px; height: 1px;}
//--></style>
'); }


/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- navigation --------------------------------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */

function navigation() {
echo "<p><form action=\"" . $_SERVER['PHP_SELF'] . "\" method=\"post\" name=\"nav\">
	<table width=\"100%\">
	<tr>
		<td><input name=\"page\" type=\"radio\" value=\"home\" />Home</td>
		<td><input name=\"page\" type=\"radio\" value=\"checkphp\" />Check PHP version</td>
		<td><input name=\"page\" type=\"radio\" value=\"phpinfo\" />Detailed PHP info</td>
		<td><input name=\"page\" type=\"radio\" value=\"checkdb\" />Check database</td>
		<td><input name=\"page\" type=\"radio\" value=\"support\" />Contact support</td>
		<td><input name=\"uppersubmit\" type=\"submit\" value=\"Go\" /></td>
	</tr>
</table>
</form>
</p>\n"; }


/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- introductionary page ----------------------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */

function welcome($application_name) {
echo "<p>Welcome! <br />
This script will help you evaluate whether it is possible to run $application_name on this web server. <br />
Please choose from the options above to proceed. <br />
<br />
If you run into any errors, please make a copy of the error message and contact support.</p>\n"; }


/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- php/zend version checks -------------------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */

function checkphp($application_name,$check_version_php,$check_version_zend,$required_version_php,$required_version_zend) {
IF ($check_version_php) {
  $installed_version_php  = phpversion();
  // version_compare() returns -1 if the first version is lower than the second, 0 if they are equal, and +1 if the second is lower.
  echo "<p>\n\tYour PHP version is $installed_version_php which is ";
  IF (version_compare($installed_version_php,$required_version_php, ">=") != "1") { 
    echo "NOT "; }
  echo "sufficient to install $application_name (requires version $required_version_php).\n</p>\n"; }

IF ($check_version_zend) {
  $installed_version_zend = zend_version();
  // version_compare() returns -1 if the first version is lower than the second, 0 if they are equal, and +1 if the second is lower.
  echo "<p>\n\tYour Zend version is $installed_version_zend which is ";
  IF (version_compare($installed_version_zend,$required_version_zend, ">=") != "1") { echo "NOT "; }
  echo "sufficient to install $application_name (requires version $required_version_zend).\n</p>\n"; } }


/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- database checks ---------------------------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */

function checkdb($application_name,$required_version_mysql) {
$mysql_host     = $_POST["mysql_host"];
$mysql_user     = $_POST["mysql_user"];
$mysql_password = $_POST["mysql_password"];
$mysql_database = $_POST["mysql_database"];
$submitted      = isset($_POST["lowersubmit"]);

/*
echo "<p>\n\tDEBUG: <br />\n\tmysql_host: $mysql_host, mysql_user: $mysql_user, mysql_password: $mysql_password, mysql_database: $mysql_database <br />\n</p>\n";
*/

// set database hostname to "localhost" if omitted.
IF ( $mysql_host == "" ) { 
  $mysql_host = "localhost"; }

// check whether all input fields have been filled
IF ( $mysql_user == "" OR $mysql_password == "" ) {

// only return an error if form has been submitted yet (i.e. it is NOT the first time the page displays)
  IF ( $submitted ) {
    echo "<p>\n\tERROR: You missed to provide the following detail. Please correct this and try again. <br />\n";
    IF ( $mysql_user == "" ) { 
      echo "\t- mysql user name <br />\n"; }
    IF ( $mysql_password == "" ) { 
      echo "\t- mysql password <br />\n"; }
/*
    IF ( $mysql_database == "" ) { 
      echo "\t- mysql database to check for <br />\n"; }
*/
  }
    echo ("</p>\n
<p>
	Please enter the following data to set up a connection to your mysql database server. <br />
	<form action=\"" . $_SERVER['PHP_SELF'] . "\" method=\"post\" name=\"database\">
		<input name=\"page\" type=\"hidden\" value=\"checkdb\" />
		Hostname or IP address of mysql database server (if you are unsure keep \"localhost\") <br />
		<input name=\"mysql_host\" type=\"text\" value=\"$mysql_host\" size=\"30\" maxlength=\"30\" /><br />
		Username for logging into this database server <br />
		<input name=\"mysql_user\" type=\"text\" value=\"$mysql_user\" size=\"30\" maxlength=\"30\" /><br />
		Password for logging into this database server <br />
		<input name=\"mysql_password\" type=\"password\" value=\"$mysql_password\" size=\"30\" maxlength=\"30\" /><br />
<!--
		Name of database to check for <br />
		<input name=\"mysql_database\" type=\"text\" value=\"$mysql_database\" size=\"30\" maxlength=\"30\" /><br />
-->
		<input name=\"lowersubmit\" type=\"submit\" value=\"Submit\" /> <br />
	</form>
</p>\n"); }
ELSE {
// Setup database server connection 
IF ($link = @mysql_connect("$mysql_host", "$mysql_user", "$mysql_password")) {
  echo "<p>Connection to database server established successfully.</p>\n";

  $installed_version_mysql = mysql_get_server_info();
  // version_compare() returns -1 if the first version is lower than the second, 0 if they are equal, and +1 if the second is lower.
  echo "<p>\n\tYour MySQL version is $installed_version_mysql which is ";
  IF (version_compare($installed_version_mysql,$required_version_mysql, ">=") != "1") { echo "NOT "; }
  echo "sufficient to install $application_name (requires version $required_version_mysql).\n</p>\n";
  
/*
  IF (mysql_select_db("$mysql_database")) {
    // alternatively one could use the following which should also work with PHP < v4.0.5 
    $query = "select version();";
    $result = mysql_query($query);
    IF ($result) { 
      echo "MySQL database version: ";
      while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
        foreach ($line as $col_value) {
          echo $col_value; } }
      mysql_free_result($result); }
    ELSE {
      echo("Database query \"$query\" failed: <br />\n" 
      . mysql_error() . " (error " . mysql_errno() . ")"); } }
  ELSE {
    echo("Could not select database \"$mysql_database\"."); }
*/
  mysql_close($link); }
ELSE { 
  echo("Error connecting to database server \"$mysql_host\" using username \"$mysql_user\" and password \"$mysql_password\": <br />\n" 
. mysql_error() . " (error " . mysql_errno() . ")"); } } }


/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- support request page ----------------------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */

function support($application_name,$support_url) {
echo "<p>For further instructions please get in touch with <a href=\"$support_url\">custumer support</a>. <br />
Thank you for using $application_name."; }


/* ------------------------------------------------------------------------------------------------------------------------- */
/* ---------- main() ------------------------------------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------------------------------------- */

IF ( isset($page) ) {
	$page = $_POST["page"];
}

htmlheader();

navigation();

IF ( !isset($page) OR ( $page == "home" ) ) { 
	welcome($application_name);
}
ELSE IF ( $page == "checkphp" ) { 
	checkphp($application_name,$check_version_php,$check_version_zend,$required_version_php,$required_version_zend);
}
ELSE IF ( $page == "phpinfo" ) { 
	phpinfo(); 
}
ELSE IF ( $page == "checkdb" ) { 
	checkdb($application_name,$required_version_mysql); 
}
ELSE IF ( $page == "support" ) { 
	support($application_name,$support_url); 
}
ELSE { 
	echo "Invalid function!"; 
}
?>